// I/O for Windows. Automatically saves/loads settings for Windows,
// as well as giving the user the ability to save manually.
// Again, unless it's Persona or too old.

if not WindowsTheComputer then return end
if srb2p then return end

// Client-side.
local music = CV_FindVar("canyon.mid")
local windbg = CV_FindVar("windbg")
local dxhudalt = CV_FindVar("dxhudalt")
local flash = CV_FindVar("winflash")
local clock = CV_FindVar("wintimer")
// Server-side.
local kart = CV_FindVar("kartgrow")
local dx = CV_FindVar("DirectX")
local bubble = CV_FindVar("winbubble")
local token = CV_FindVar("TokenCompile")
local ssd = CV_FindVar("ssd")
local funny = CV_FindVar("funindeath")
local funnychance = CV_FindVar("funindeathchance")

// Generate config is not present.
// Client.
if io.openlocal("client/windows/system.dat") == nil then
	print("\x85\Missing client configuration file, generating a default one...")
	local restore = io.openlocal("client/windows/system.dat", "w+")
	restore:write(music.value, "\n", windbg.value, "\n", dxhudalt.value, "\n", flash.value, "\n", clock.value)
	restore:close()
	if windbg.value then print("Closing the file handle...") end
end

// Server.
if io.openlocal("client/windows/explorer.dat") == nil then
	print("\x85\Missing server configuration file, generating a default one...")
	local generate = io.openlocal("client/windows/explorer.dat", "w+")
	generate:write(kart.value, "\n", dx.value, "\n", bubble.value, "\n", token.value, "\n", ssd.value, "\n", funny.value, "\n", funnychance.value)
	generate:close()
	if windbg.value then print("Closing the file handle...") end
end

// Thanks, MACHTURNE!
local function fixedToFloat(n)
	local str = (n < 0 and "-" or "") .. tostring(abs(n)/FRACUNIT)
	if not (n % FRACUNIT) then return str end
	n = abs(n) % FRACUNIT
	str = $ .. "."
	while n > 0 do
		n = $ * 10
		str = $ .. tostring(n >> FRACBITS)
		n = $ & (FRACUNIT-1)
	end
	return str
end

COM_AddCommand("registry", function(p, arg)
	if arg then
		arg = arg:lower()
		if arg == "save" then
			local backup = io.openlocal("client/windows/explorer.dat", "w+")
			if windbg.value then CONS_Printf(p, "Attempting to write to 'client/windows/explorer.dat'...") end
			backup:write(kart.value, "\n", dx.value, "\n", bubble.value, "\n", token.value, "\n", ssd.value, "\n", funny.value, "\n", funnychance.value)
			backup:close()
			if windbg.value then CONS_Printf(p, "Closing the file handle...") end
			CONS_Printf(p, "\x82\Windows: \x83\Saved server settings.")
			S_StartSound(nil, sfx_cpanel, consoleplayer)
			local save = io.openlocal("client/windows/system.dat", "w+")
			if windbg.value then CONS_Printf(p, "Attempting to write to 'client/windows/system.dat'...") end
			if save then
				save:write(music.value, "\n", windbg.value, "\n", dxhudalt.value, "\n", flash.value, "\n", clock.value)
				save:close()
				if windbg.value then CONS_Printf(p, "Closing the file handle...") end
				CONS_Printf(p, "\x82\Windows: \x83\Saved client settings.")
			end
		elseif arg == "load" then
			local startupdisk = io.openlocal("client/windows/system.dat")
			if startupdisk then
				local client = 0
				if windbg.value then CONS_Printf(p, "Attempting to read from 'client/windows/system.dat'...") end
				client = startupdisk:read()
				CV_StealthSet(music, client)
				client = startupdisk:read()
				CV_StealthSet(windbg, client)
				client = startupdisk:read()
				CV_StealthSet(dxhudalt, client)
				client = startupdisk:read()
				CV_StealthSet(flash, client)
				client = startupdisk:read()
				CV_StealthSet(clock, client)
				CONS_Printf(p, "\x82\Windows: \x83\Loaded client settings.")
				startupdisk:close()
				if windbg.value then CONS_Printf(p, "Closing the file handle...") end
			else
				local save = io.openlocal("client/windows/system.dat", "w+")
				if save then
					save:write(music.value, "\n", windbg.value, "\n", dxhudalt.value, "\n", flash.value, "\n", clock.value)
					save:close()
					CONS_Printf(p, "\x82\Windows: \x85\Client file was not detected, generating one")
					CONS_Printf(p, "\x85\with currently active settings...")
				end
			end
			if not (p == server or isserver or isdedicatedserver) then
				CONS_Printf(p, "\x82\Windows: \x85\You are not the host of this netgame.")
				return
			end
			local update = io.openlocal("client/windows/explorer.dat")
			local patch = 0
			if windbg.value then CONS_Printf(p, "Attempting to read from 'client/windows/explorer.dat'...") end
			patch = update:read()
			CV_StealthSet(kart, patch)
			patch = update:read()
			CV_StealthSet(dx, patch)
			patch = update:read()
			CV_StealthSet(bubble, patch)
			patch = update:read()
			CV_StealthSet(token, patch)
			patch = update:read()
			CV_StealthSet(ssd, patch)
			patch = update:read()
			CV_StealthSet(funny, patch)
			patch = tonumber(update:read())
			if patch < 0 or patch > FRACUNIT then
				CONS_Printf(p, "\x85\Value set is out of range, using default value instead.")
				CONS_Printf(p, "\x85\Save the configuration file to no longer see this message.")
				patch = 8192
			end
			patch = fixedToFloat(patch)
			CV_StealthSet(funnychance, patch)
			S_StartSound(nil, sfx_cpanel, consoleplayer)
			CONS_Printf(p, "\x82\Windows: \x83\Loaded server settings.")
			update:close()
			if windbg.value then CONS_Printf(p, "Closing the file handle...") end
		else
			CONS_Printf(p, "The syntax of the command is incorrect.")
		end
	else
		CONS_Printf(p, "Using this command, you can manually save/load client/server settings,")
		CONS_Printf(p, "related to \x82\Windows. \x80\Loading server settings requires you to be")
		CONS_Printf(p, "the host of the server. To activate the saving/loading process, use")
		CONS_Printf(p, "'\x82\registry save' \x80\or '\x82\registry load'.")
	end
end)

// Auto-save.
addHook("GameQuit", function()
	local save = io.openlocal("client/windows/system.dat", "w+")
	if save then
		save:write(music.value, "\n", windbg.value, "\n", dxhudalt.value, "\n", flash.value, "\n", clock.value)
		save:close()
		if windbg.value then CONS_Printf(consoleplayer, "Closing the file handle...") end
	end
end)

// Auto-load.
local msnclient = io.openlocal("client/windows/system.dat")
if msnclient then
	if windbg.value then print("Attempting to read from 'client/windows/system.dat'...") end
	local client = 0
	client = msnclient:read()
	CV_StealthSet(music, client)
	client = msnclient:read()
	CV_StealthSet(windbg, client)
	client = msnclient:read()
	CV_StealthSet(dxhudalt, client)
	client = msnclient:read()
	CV_StealthSet(flash, client)
	client = msnclient:read()
	CV_StealthSet(clock, client)
	print("\x82\Windows: \x83\Loaded client settings.")
	msnclient:close()
	if windbg.value then print("Closing the file handle...") end
end