// Tokens & Windows, KeepShield, CrossMomentum compatibility,
// The Funny, BattleMod, Ringslinger NEO, RushChars...
// ...and dashmode?

if not WindowsTheComputer then return end
freeslot("SFX_FUNDIE", "SFX_MUSMN1", "SFX_MUSMN2")

sfxinfo[sfx_fundie] = {
	singular = false,
	priority = 32,
	flags = SF_X4AWAYSOUND,
	caption = "funnydeath.mp4"
}

sfxinfo[sfx_musmn1] = {
	singular = false,
	priority = 50,
	caption = "Musica Menu Popup"
}

sfxinfo[sfx_musmn2] = {
	singular = false,
	priority = 50,
	caption = "Musica Menu Command"
}

sfxinfo[sfx_cdfm67].caption = "Ring Spill"
sfxinfo[sfx_cdfm73].caption = "Perfect!"

if srb2p then return end

local function controlpanel()
	S_StartSound(nil, sfx_uihmsn, consoleplayer)
end

local netframework = CV_RegisterVar({ // Compromise with having default special stages.
	name = "TokenCompile",
	defaultvalue = 0,
	flags = CV_NETVAR | CV_SHOWMODIF,
	PossibleValue = {default=0, legacy=1},
	func = controlpanel
})

local function Token2GemSFX()
	S_StartSound(nil, sfx_cgot)
	S_StartSound(nil, sfx_chchng)
end

local function TokenWindowsReward()
	for player in players.iterate
		P_GivePlayerRings(player, 50) // Rings, people, Rings!
		S_StartSound(player.mo, sfx_cdfm67, player)
	end
end

// The old special stages continue Lua.
// Script by SteelT.
local therings = 0
local roundedcorners = 0
local gotem = false

addHook("MapLoad", function(gamemap)
	therings = 0
	roundedcorners = 0
	gotem = false
	if (multiplayer) then return end
	if (maptol & TOL_NIGHTS) then return end
	if (G_IsSpecialStage(gamemap)) then
		for item in mobjs.iterate() do
			if (item.type == MT_RING) then therings = $ + 1 end
			if (item.type == MT_BLUESPHERE) then roundedcorners = $ + 1 end
		end
		for player in players.iterate
			if player.mo and player.mo.valid and player.mo.skin == "windows" then player.getsphere = 0 end
		end
	end
end)

addHook("TouchSpecial", function(special, play)
	if (multiplayer) or (maptol & TOL_NIGHTS) then return end
	if (play and play.valid) and play.skin == "windows" and play.player and play.player.valid then
		if play.player.getsphere < roundedcorners then play.player.getsphere = $ + 1 end
		if CV_FindVar("windbg").value then print(play.player.getsphere) end
	end
end, MT_BLUESPHERE)

addHook("PlayerThink", function(player)
	if player.mo.skin != "windows" then return end
	if (multiplayer) then return end
	if (maptol & TOL_NIGHTS) then return end
	if (G_IsSpecialStage(gamemap)) then
		if (therings > 0 and player.rings >= therings/2) and not player.gotcontinue then
			player.gotcontinue = 1
			player.continues = $ + 1
			S_StartSound(nil, sfx_s3kac, player)
		end
		if (roundedcorners > 0 and player.getsphere >= roundedcorners - 2) and (player.rings >= therings) and not gotem then
			gotem = true
			player.rings = $ + 1000
			S_StartSound(nil, sfx_cdfm73, player)
		end
		if player.exiting > 0 and player.gotcontinue then
			if leveltime%5 == 1 then
				local glow = P_SpawnGhostMobj(player.mo)
				glow.destscale = player.mo.scale*32
				glow.flags = $ & ~MF_NOCLIPHEIGHT
			end
		end
	end
end)

// From KeepShield V3 by Zippy_Zolton.
// Be smart with which shield you finish a level with.
// Might help you or end up being useless.
addHook("PlayerThink", function(player)
	if (player.mo and player.mo.valid) and player.mo.skin != "windows" then return
	elseif (player.mo and player.mo.valid) and player.mo.skin == "windows" then
		if not (player and player.mo and player.mo.valid and player.exiting and (gametyperules & GTR_FRIENDLY)) return end
		player.shieldtransfer = player.powers[pw_shield]
	end
end)

addHook("PlayerSpawn", function(player)
	if (player.mo and player.mo.valid) then
		if player.shieldtransfer == nil or not (gametyperules & GTR_FRIENDLY) then return end
		if player.mo.skin != "windows" then return
		elseif player.mo.skin == "windows" then
			player.powers[pw_shield] = player.shieldtransfer
			P_SpawnShieldOrb(player)
			player.shieldtransfer = nil
		end
	end
end)

// Actual token shenanigans.
addHook("TouchSpecial", function(special, grabber)
	if (grabber and grabber.valid) and grabber.skin != "windows" then return
	elseif (grabber and grabber.valid) and grabber.skin == "windows" then
		if not OLDC then
			if netframework.value == 1 then
				if emeralds & EMERALD1 == 0 then
					emeralds = $ | EMERALD1
					Token2GemSFX()
					P_AddPlayerScore(grabber.player, 2500)
				elseif emeralds & EMERALD2 == 0 then
					emeralds = $ | EMERALD2
					Token2GemSFX()
					P_AddPlayerScore(grabber.player, 2500)
				elseif emeralds & EMERALD3 == 0 then
					emeralds = $ | EMERALD3
					Token2GemSFX()
					P_AddPlayerScore(grabber.player, 2500)
				elseif emeralds & EMERALD4 == 0 then
					emeralds = $ | EMERALD4
					Token2GemSFX()
					P_AddPlayerScore(grabber.player, 2500)
				elseif emeralds & EMERALD5 == 0 then
					emeralds = $ | EMERALD5
					Token2GemSFX()
					P_AddPlayerScore(grabber.player, 2500)
				elseif emeralds & EMERALD6 == 0 then
					emeralds = $ | EMERALD6
					Token2GemSFX()
					P_AddPlayerScore(grabber.player, 2500)
				elseif emeralds & EMERALD7 == 0 then
					emeralds = $ | EMERALD7
					Token2GemSFX()
					P_AddPlayerScore(grabber.player, 2500)
				else TokenWindowsReward() end
			else
				if not All7Emeralds(emeralds) then
					token = $ + 1
					S_StartSound(grabber, sfx_zelda)
				else
					TokenWindowsReward()
				end
				P_AddPlayerScore(grabber.player, 2500)
				S_StartSound(grabber, sfx_chchng)
			end
			P_KillMobj(special)
			return true
		end
	end
end, MT_TOKEN)

// CrossMomentum compatibile custom top speeds.
// Dashmode included.
addHook("ThinkFrame", function()
	for player in players.iterate
		if (player.mo and player.mo.valid) and player.mo.skin != "windows" then return
		elseif (player.mo and player.mo.valid) and player.mo.skin == "windows" then
			if (player.isxmomentum and not player.xmomtoggledoff) and player.fakenormalspeed < skins[player.mo.skin].normalspeed then
				player.fakenormalspeed = skins[player.mo.skin].normalspeed
			elseif not player.isxmomentum or player.normalspeed < skins[player.mo.skin].normalspeed then
				player.normalspeed = skins[player.mo.skin].normalspeed
			end
			if not P_IsObjectOnGround(player.mo) and player.cpucooler then
				if (player.isxmomentum and not player.xmomtoggledoff) and player.fakenormalspeed < (skins[player.mo.skin].normalspeed * 3) / 2 then
					player.fakenormalspeed = (skins[player.mo.skin].normalspeed * 3) / 2
				elseif not player.isxmomentum or player.normalspeed < (skins[player.mo.skin].normalspeed * 3) / 2 then
					player.normalspeed = (skins[player.mo.skin].normalspeed * 3) / 2
				end
			elseif (player.powers[pw_invulnerability] != 0 and player.powers[pw_sneakers] == 0) then
				if (player.isxmomentum and not player.xmomtoggledoff) and player.fakenormalspeed < (skins[player.mo.skin].normalspeed * 4) / 3 then
					player.fakenormalspeed = (skins[player.mo.skin].normalspeed * 4) / 3
				elseif not player.isxmomentum or player.normalspeed < (skins[player.mo.skin].normalspeed * 4) / 3 then
					player.normalspeed = (skins[player.mo.skin].normalspeed * 4) / 3
				end
			elseif player.powers[pw_sneakers] != 0 then
				if (player.isxmomentum and not player.xmomtoggledoff) and player.fakenormalspeed < (skins[player.mo.skin].normalspeed * 5) / 4 then
					player.fakenormalspeed = (skins[player.mo.skin].normalspeed * 5) / 4
				elseif not player.isxmomentum or player.normalspeed < (skins[player.mo.skin].normalspeed * 5) / 4 then
					player.normalspeed = (skins[player.mo.skin].normalspeed * 5) / 4
				end
			else
				if (player.isxmomentum and not player.xmomtoggledoff) and player.fakenormalspeed > skins[player.mo.skin].normalspeed then
					player.fakenormalspeed = skins[player.mo.skin].normalspeed
				elseif not player.isxmomentum or player.normalspeed < skins[player.mo.skin].normalspeed then
					player.normalspeed = skins[player.mo.skin].normalspeed
				end
			end
			if player.powers[pw_super] != 0 or (player.solchar and player.solchar.istransformed and player.solchar.istransformed > 1) then
				if (player.isxmomentum and not player.xmomtoggledoff) then
					if player.hyper and player.hyper.capable then
						player.fakenormalspeed = (skins[player.mo.skin].normalspeed * 3)
					else
						if (player.solchar and player.solchar.istransformed and player.solchar.istransformed > 1)
						and player.fakenormalspeed < (skins[player.mo.skin].normalspeed * 7) / 3 then
							player.fakenormalspeed = (skins[player.mo.skin].normalspeed * 7) / 3
						else
							player.fakenormalspeed = (skins[player.mo.skin].normalspeed * 3) / 2
						end
					end
				else
					if (player.solchar and player.solchar.istransformed and player.solchar.istransformed > 1)
					and player.normalspeed < (skins[player.mo.skin].normalspeed * 7) / 3 then
						player.normalspeed = (skins[player.mo.skin].normalspeed * 7) / 3
					else
						player.normalspeed = (skins[player.mo.skin].normalspeed * 3) / 2
					end
				end
			end
			// Top speeds when DirectX Boosting... or you managed to get Windows to use dashmode.
			if player.cpanel > 0 or (player.charflags & SF_DASHMODE and player.dashmode >= 3*TICRATE) and player.playerstate == PST_LIVE then
				if player.exiting != 0 then player.cpanel = 0 end
				if P_PlayerInPain(player) == true then player.cpanel = 0 end
				if (player.charflags & SF_DASHMODE and player.dashmode >= 3*TICRATE) and player.cpanel > 0 then player.cpanel = 0 end
				player.thrustfactor = (skins[player.mo.skin].thrustfactor * 7) / 4
				if player.powers[pw_super] == 0 and not (player.solchar and player.solchar.istransformed and player.solchar.istransformed > 1) then
					if (player.isxmomentum and not player.xmomtoggledoff) and player.fakenormalspeed < (skins[player.mo.skin].normalspeed * 9) / 4 then
						player.fakenormalspeed = (skins[player.mo.skin].normalspeed * 9) / 4
					elseif not player.isxmomentum or player.normalspeed < (skins[player.mo.skin].normalspeed * 9) / 4 then
						player.normalspeed = (skins[player.mo.skin].normalspeed * 9) / 4
					else
						if player.dashmode >= 3*TICRATE and player.charflags & SF_DASHMODE and player.normalspeed < (skins[player.mo.skin].normalspeed * 9) / 4 then
							player.normalspeed = (skins[player.mo.skin].normalspeed * 9) / 4
						end
					end
				elseif player.powers[pw_super] != 0 or (player.solchar and player.solchar.istransformed and player.solchar.istransformed > 1) then
					if (player.isxmomentum and not player.xmomtoggledoff) then
						if player.hyper and player.hyper.capable then
							if player.fakenormalspeed < (skins[player.mo.skin].normalspeed * 6) then
								player.fakenormalspeed = (skins[player.mo.skin].normalspeed * 6)
							end
						else
							if (player.solchar and player.solchar.istransformed and player.solchar.istransformed > 1) and player.fakenormalspeed < (skins[player.mo.skin].normalspeed * 11) / 3 then
								player.fakenormalspeed = (skins[player.mo.skin].normalspeed * 11) / 3
							else
								if player.fakenormalspeed < (skins[player.mo.skin].normalspeed * 3) then
									player.fakenormalspeed = (skins[player.mo.skin].normalspeed * 3)
								end
							end
						end
					else
						if (player.solchar and player.solchar.istransformed and player.solchar.istransformed > 1) and player.normalspeed < (skins[player.mo.skin].normalspeed * 11) / 3 then
							player.normalspeed = (skins[player.mo.skin].normalspeed * 11) / 3
						else
							if player.normalspeed < (skins[player.mo.skin].normalspeed * 3) then
								player.normalspeed = (skins[player.mo.skin].normalspeed * 3)
							end
						end
					end
				end
			end
		end
	end
end)

// The Funny Switch.
local funnydeath = CV_RegisterVar({
	name = "funindeath",
	defaultvalue = 1,
	flags = CV_NETVAR | CV_SHOWMODIF | CV_CALL,
	PossibleValue = {disabled=0, enabled=1},
	func = controlpanel
})

// Chance for a funny death no longer hardcoded.
local funnydeathchance = CV_RegisterVar({
	name = "funindeathchance",
	defaultvalue = "0.125",
	flags = CV_NETVAR | CV_SHOWMODIF | CV_CALL | CV_FLOAT,
	PossibleValue = {min = 0, max = FRACUNIT},
	func = controlpanel
})

addHook("PlayerThink", function(player)
	if not (player and player.valid and player.mo and player.mo.valid) then return end
	if player.mo.destscale > player.mo.scale then
		if not S_SoundPlaying(player.mo, sfx_kc5a) then
			S_StartSound(player.mo, sfx_kc5a)
		end
	elseif player.mo.destscale < player.mo.scale then
		if not S_SoundPlaying(player.mo, sfx_kc59) then
			S_StartSound(player.mo, sfx_kc59)
		end
	end
	if funnydeath.value != 1 then return end
	if player.playerstate == PST_DEAD and player.fundeath == 0 then
		if P_RandomChance(funnydeathchance.value) then
			player.mo.flags2 = $ | MF2_DONTDRAW
			local flatulence = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_BOSSEXPLODE)
			flatulence.scale = 3 << FRACBITS
			player.fundeath = 1
			player.hasfundie = true
		else
			player.fundeath = 2
		end
	end
	if player.playerstate == PST_DEAD then
		if player.fundeath == 1 then
			player.mo.momx = 0
			player.mo.momy = 0
			player.mo.momz = 0
			if not S_SoundPlaying(player.mo, sfx_fundie) then
				S_StopSound(player.mo)
				S_StartSound(player.mo, sfx_fundie)
			end
			player.mo.fuse = 1
			player.fundeath = 2
		end
	else
		if player.fundeath != 0 then player.fundeath = 0 end
		if player.hasfundie then player.hasfundie = false end
	end
end)

// Battlemod.
local dx = CV_FindVar("DirectX")
local ScriptLoaded = false
addHook("ThinkFrame", function()
	if not (ScriptLoaded) and CBW_Battle then
		ScriptLoaded = true
		print("BattleMod compatibility for Windows The Computer initialized.")
		local B = CBW_Battle
		local IR95 = function(mo,doaction)
			local player = mo.player
			player.actiontext = "Infrared Blast"
			player.actionrings = 25
			if not (B.CanDoAction(player)) then player.actionstate = 0 return end	
			if player.actionstate == 0 then
				if doaction == 1 then
					player.actionstate = 1
					player.actiontime = 0
					B.PayRings(player)
					S_StartSound(mo,sfx_s3k3c)
				end
			end
			if player.actionstate == 1 then
				player.actiontime = $+1
				P_InstaThrust(mo,mo.angle,0)
				P_SetObjectMomZ(mo,P_MobjFlip(mo)*mo.scale,0)
				player.pflags = ($|PF_SPINNING)&~PF_JUMPED
				mo.state = S_PLAY_JUMP
				if player.actiontime%3 == 0 then P_SpawnThokMobj(player) end
				if player.actiontime == 1 then
					S_StartSound(mo, sfx_musmn1)
				elseif player.actiontime == 20 then
					player.actionstate = 2
					player.actiontime = 0
				end
			end
			if player.actionstate == 2 then
				player.actiontime = $+1
				B.ApplyCooldown(player,TICRATE*20)
				mo.state = S_PLAY_EDGE
				player.pflags = $&~(PF_SPINNING)
				player.drawangle = mo.angle
				if player.actiontime == 2 then
					S_StartSound(mo, sfx_musmn2)
					P_NukeEnemies(mo, mo, 768*FRACUNIT)
					local irq = P_SpawnGhostMobj(mo)
					irq.destscale = mo.scale*32
					P_InstaThrust(mo, mo.angle, -mo.height/2)
					mo.state = S_PLAY_FALL
					player.actionstate = 0
				end
			end
		end
		local PriorityFunc = function(player)
			if player.actionstate == 1 then
				B.SetPriority(player,1,3,nil,1,3,"Infrared Blast")
			end
		end
		local DXExhaust = function(player)
			local maxtime = 0
			if player.cpanel > 0 and dx.value then
				if maxtime < player.cpanel then maxtime = player.cpanel end
				player.exhaustmeter = max(0,$-FRACUNIT/maxtime)
				return true
			end
			return false
		end
		local CollideFunc = function(n1,n2,plr,mo,atk,def,weight,hurt,pain,ground,angle,thrust,thrust2,collisiontype)
			if not (plr[n1] and plr[n1].valid and plr[n1].playerstate == PST_LIVE)
				or not mo[n1].health
				or not mo[n1].state == S_PLAY_ROLL
				or not mo[n1].state == S_PLAY_JUMP
				or pain[n1]
				return false
			end
			if (hurt != 1 and n1 == 1) or (hurt != -1 and n1 == 2)
				S_StartSound(mo[n1], sfx_lose)
				return true
			end
		end
		CBW_Battle.SkinVars["windows"] = {
			special = IR95,
			func_priority_ext = PriorityFunc,
			func_exhaust = DXExhaust,
			func_collide = CollideFunc
		}
	end
end)

// Ringslinger NEO.
local rs_loaded = false
addHook("ThinkFrame", function()
	if RingSlinger and not rs_loaded
		rs_loaded = true;
		RingSlinger.AddWeapon({
			name = "File",
			viewsprite = "FILEFOLDER",
			hudsprite = "FILEHUD",
			mt = MT_WINFILE,
			sound = sfx_fileth,
			scale = (9*FRACUNIT)/4,
			viewoffset = -20*FRACUNIT,
			auto = true,
			delay = 20,
			shake = 1,
			cost = 6
		})
		RingSlinger.Skins["windows"] = {
			ammo = 32,
			weapons = {RSWPN_FILE, RSWPN_RAIL}
		}
		print("Loaded RingSlinger support for Windows The Computer.")
	end
end)

if not (solchars and boatchars) then return end
addHook("MobjThinker", function(mo)
	if (mo.rider and mo.rider.valid and mo.rider.health) then
		local player = mo.rider.player
		if not mo.rider.skin == "windows" then return end
		if player.pflags & PF_JUMPED then player.pflags = $ & ~PF_JUMPED end
		if mo.jumpsdone == nil then mo.jumpsdone = 0 end
		if mo.jumpdelay == nil then mo.jumpdelay = 0 end
		if mo.isjumphold == nil then mo.isjumphold = false end
		if (P_IsObjectOnGround(mo) or (mo.onwater) or (mo.wasinwater)) and mo.jumpsdone != 0 then mo.jumpsdone = 0 end
		if CV_FindVar("windbg").value then CONS_Printf(player, mo.jumpsdone + "/" + mo.jumpdelay + "/" + mo.isjumphold) end
		if player.cmd.buttons & BT_JUMP then
			if not mo.isjumphold then
				if mo.jumpsdone < 3 and mo.jumpdelay == 0 then
					mo.startjump = true
					mo.jumpsdone = $ + 1
					mo.jumpdelay = TICRATE/2
					mo.isjumphold = true
					P_SetObjectMomZ(mo, 10*FRACUNIT, false) 
					S_StartSound(mo, sfx_jskijm)
					local jumpy = P_SpawnGhostMobj(mo.rider)
					jumpy.destscale = mo.scale*4
					mo.allowjumpinwater = true
					P_ResetScore(player)
				end
			end
		else
			if mo.isjumphold then mo.isjumphold = false end
		end
		if mo.jumpdelay >= 1 then mo.jumpdelay = $ - 1 else mo.jumpdelay = 0 end
		if player.exiting > 0 then
			local p = player
			P_TeleportMove(mo.rider, mo.x, mo.y, mo.z+mo.height*2*P_MobjFlip(mo))
			p.mo.tracer = nil
			if mo.overlay.frame == 2
				mo.overlay.frame = 0
			elseif mo.overlay.frame == 3
				mo.overlay.frame = 1
			end
			p.eoiudjgjfih = true
			p.mo.noboatmount = TICRATE*3
			mo.rider.spriteyoffset = 0
			if mo.rider.health then p.mo.state = S_PLAY_FALL end
			mo.flags = $ & ~MF_NOBLOCKMAP
			mo.rider.flags2 = $&~MF2_DONTDRAW
			mo.rider.shadowscale = mo.rider.storedshadowscale
			mo.rider.storedshadowscale = nil
			if p.powers[pw_carry] == 19 p.powers[pw_carry] = 0 end
			mo.overlay.flags2 = $&~MF2_DONTDRAW
			mo.rider.rollangle = 0
			mo.rider.boattilt = 0
			if mo.gasgasgas or not (boatchars[p.mo.skin] and boatchars[p.mo.skin][1])
				S_StopSound(mo)
				S_StartSound(mo, sfx_jskidm)
			end
			P_RestoreMusic(p)
			mo.rider = nil
			p.mo.boat = nil
			S_StartSound(mo.rider, sfx_musmn2)
		end
	end
end, MT_MARINEJETSKI)