// Super form ability.
// As well as the Hyper extension, if XMomentum is present.

if not WindowsTheComputer then return end
freeslot("SFX_XPBMB", "SFX_NT5PWR", "SFX_WINRDY", "SFX_NOXMOM", "SFX_NOBLST")

sfxinfo[sfx_noxmom] = {
	singular = true,
	priority = 255,
	caption = "Error"
}

sfxinfo[sfx_noblst] = {
	singular = true,
	priority = 100,
	caption = "XPerience Blast Blocked"
}

sfxinfo[sfx_xpbmb] = {
	singular = false,
	priority = 95,
	flags = SF_X8AWAYSOUND,
	caption = "XPerience Blast"
}

sfxinfo[sfx_winrdy] = {
	singular = false,
	priority = 80,
	flags = SF_X2AWAYSOUND,
	caption = "Blast Ready"
}

sfxinfo[sfx_nt5pwr] = {
	singular = false,
	priority = 95,
	flags = SF_X2AWAYSOUND|SF_X4AWAYSOUND|SF_X8AWAYSOUND,
	caption = "The NT5 Revolution"
}

// Unless it's Persona...
if srb2p then return end

local function controlpanel()
	S_StartSound(nil, sfx_uihmsn, consoleplayer)
end

local logoff = false

addHook("MapLoad", function(gamemap)
	if mapheaderinfo[gamemap].nextlevel == 1103
	or (mapheaderinfo[gamemap].nextlevel <= 27 and mapheaderinfo[gamemap].nextlevel > 1) then logoff = true else logoff = false end
end)

// Local flash variable. Not Flash, though.
local protecteyes = CV_RegisterVar({
	name = "winflash",
	defaultvalue = 0,
	flags = CV_SHOWMODIF | CV_CALL,
	PossibleValue = {noflash=0, flash=1},
	func = controlpanel
})

local mobjscale = CV_FindVar("kartgrow")
local hyperblast = false

COM_AddCommand("pentium4", function(player, arg)
	if not player.isxmomentum then
		CONS_Printf(player, "\x85 (X)\x80 CrossMomentum not present, aborting.")
		hyperblast = false
		player.canxpblast = false
		S_StartSound(player.mo, sfx_noxmom, player)
		return
	else
		if arg then
			arg = arg:lower()
			if arg == "0" or arg == "no" or arg == "safe" then
				if hyperblast != false then
					S_StartSound(nil, sfx_uihmsn, player)
					for safe in players.iterate
						CONS_Printf(safe, "Administrator/host has disabled Hyper XPereience Blasts.")
						player.canxpblast = false
					end
				else
					CONS_Printf(player, "Hyper XPereience Blasts already disabled.")
				end
				hyperblast = false
			elseif arg == "1" or arg == "yes" or arg == "ohgodno" then
				if hyperblast != true then
					CONS_Printf(player, "\x82 (!)\x80 Pentium 4 Mode Unlocked. You have been warned.")
					CONS_Printf(player, "Windows can do XPerience Blasts if Hyper.")
					S_StartSound(nil, sfx_uihmsn, player)
					for ohno in players.iterate
						if ohno != player then
							CONS_Printf(ohno, "\x82 (!)\x80 Administrator/host has enabled Hyper XPereience Blasts.")
							CONS_Printf(ohno, "This may lead to lag or, at worst, crashes.")
							CONS_Printf(ohno, "Brace yourself for impact if one uses them.")
							player.canxpblast = true
							S_StartSound(nil, sfx_s3k86, ohno)
						end
					end
				else
					CONS_Printf(player, "\x82 (!)\x80 Hyper XPereience Blasts already enabled. Godspeed.")
				end
				hyperblast = true
			end
		else
			if hyperblast then CONS_Printf(player, "\x82 (!)\x80 Pentium 4 Mode unlocked - Hyper XPerience Blasts permitted.")
			elseif not hyperblast then CONS_Printf(player, "Pentium 4 Mode locked - Hyper XPerience Blasts disallowed.")
			elseif hyperblast == nil then
				CONS_Printf(player, "\x85 (X)\x80 404: Value not initalized. Reverting to default...")
				hyperblast = false
			else
				CONS_Printf(player, "\x85 (X)\x80 Invalid value type detected. Reverting to default...")
				hyperblast = false
			end
		end
	end
end, COM_ADMIN)

COM_AddCommand("pentium4check", function(player)
	if not player.isxmomentum then
		CONS_Printf(player, "\x85 (X)\x80 CrossMomentum not present.")
		hyperblast = false
		S_StartSound(player.mo, sfx_noxmom, player)
		return
	else
		if hyperblast then CONS_Printf(player, "\x82 (!)\x80 Pentium 4 Mode unlocked - Hyper XPerience Blasts permitted.")
		elseif not hyperblast then CONS_Printf(player, "Pentium 4 Mode locked - Hyper XPerience Blasts disallowed.")
		elseif hyperblast == nil then
			CONS_Printf(player, "\x85 (X)\x80 404: Value not initalized. Reverting to default...")
			hyperblast = false
		else
			CONS_Printf(player, "\x85 (X)\x80 Invalid value type detected. Reverting to default...")
			hyperblast = false
		end
	end
end)

local function WhenYouStubYourToe(srcplayer)
	local owie = srcplayer.speed / 2
	for player in players.iterate
		P_SwitchShield(player, SH_NONE)
		if netgame then
			chatprintf(player, "Oops, " + srcplayer.name + " has overclocked their computer too much!", false)
			S_StartSound(player.mo, sfx_pinbl3, player)
		else
			CONS_Printf(player, "Oops, " + srcplayer.name + " has overclocked too much!")
		end
		P_DoPlayerPain(player)
		if FixedMul(srcplayer.speed, srcplayer.mo.scale) < 60*FRACUNIT then
			P_InstaThrust(player.mo, player.mo.angle, -60*FRACUNIT)
			P_SetObjectMomZ(player.mo, 30*FRACUNIT)
		else
			P_SetObjectMomZ(player.mo, owie / 3)
			P_InstaThrust(player.mo, player.mo.angle, owie * -1)
		end
		player.powers[pw_sneakers] = 0
		player.powers[pw_invulnerability] = 0
		if player.rings > 0 then
			P_PlayerRingBurst(player, player.rings)
			player.rings = 0
		end
		if protecteyes.value == 1 then P_StartQuake(64*FRACUNIT, 2*TICRATE) end
		S_StartSound(player.mo, sfx_nt5pwr, player)
		for i = 0, 8, 1 do
			local sparkle = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SUPERSPARK)
			sparkle.angle = FixedAngle(i*ANGLE_22h)
			P_Thrust(sparkle, sparkle.angle, 40*FRACUNIT)
		end
	end
end

addHook("PlayerThink", function(player)
	if (player.mo and player.mo.valid) and player.mo.skin != "windows" then
		player.xpcooldown = 60*TICRATE
		player.xpready = false
		if player.canxpblast == nil then player.canxpblast = hyperblast end
		return
	elseif (player.mo and player.mo.valid) and player.mo.skin == "windows" then
		// Single-player/Co-op/Competition implementation.
		if G_PlatformGametype() then
			if hyperblast or (player.hyper == nil or player.hyper.capable == false) then
				player.canxpblast = true
				if player.xpcooldown != 60*TICRATE and player.xpready == false then
					if player.xpcooldown < 60*TICRATE then
						if (player.powers[pw_invulnerability] != 0 or player.powers[pw_sneakers] != 0) then
							player.xpcooldown = $ + 2
						else
							player.xpcooldown = $ + 1
						end
					elseif player.xpcooldown > 60*TICRATE then player.xpcooldown = 60*TICRATE
					end
				elseif player.xpcooldown == 60*TICRATE then player.xpready = true
				end
				if player.xpready == false and player.xpcooldown == 60*TICRATE then
					S_StartSound(player.mo, sfx_winrdy)
					player.xpready = true
				end
			else
				player.canxpblast = false
				player.xpcooldown = 0
			end
			if player.powers[pw_shield] == 3 and player.powers[pw_super] != 0 and player.canxpblast then
				player.xpcooldown = 60*TICRATE - 5
				player.powers[pw_shield] = 0
			elseif player.powers[pw_super] == 0 then player.xpcooldown = 60*TICRATE end
			if player.cmd.buttons & BT_CUSTOM1 and not (player.cmd.buttons & BT_CUSTOM3) then
				if player.xpready then
					if player.powers[pw_super] != 0 then
						local xp = P_SpawnGhostMobj(player.mo)
						local range = 0
						if player.hyper == nil or not player.hyper.capable then
							if mobjscale.value == 1 and player.powers[pw_sneakers] != 0 then
								range = 3072*FRACUNIT
							else
								range = 1536*FRACUNIT
							end
							for dll in mobjs.iterate()
								if R_PointToDist2(player.mo.x, player.mo.y, dll.x, dll.y) > range then continue
								elseif dll.type == MT_CYBRAKDEMON_ELECTRIC_BARRIER and (dll.state == S_CYBRAKDEMONELECTRICBARRIER1
								or dll.state == S_CYBRAKDEMONELECTRICBARRIER2 or dll.state == S_CYBRAKDEMONELECTRICBARRIER3
								or dll.state == S_CYBRAKDEMONELECTRICBARRIER4 or dll.state == S_CYBRAKDEMONELECTRICBARRIER5
								or dll.state == S_CYBRAKDEMONELECTRICBARRIER6 or dll.state == S_CYBRAKDEMONELECTRICBARRIER7
								or dll.state == S_CYBRAKDEMONELECTRICBARRIER8 or dll.state == S_CYBRAKDEMONELECTRICBARRIER9
								or dll.state == S_CYBRAKDEMONELECTRICBARRIER10 or dll.state == S_CYBRAKDEMONELECTRICBARRIER11
								or dll.state == S_CYBRAKDEMONELECTRICBARRIER12 or dll.state == S_CYBRAKDEMONELECTRICBARRIER13
								or dll.state == S_CYBRAKDEMONELECTRICBARRIER14 or dll.state == S_CYBRAKDEMONELECTRICBARRIER15
								or dll.state == S_CYBRAKDEMONELECTRICBARRIER16 or dll.state == S_CYBRAKDEMONELECTRICBARRIER17
								or dll.state == S_CYBRAKDEMONELECTRICBARRIER18 or dll.state == S_CYBRAKDEMONELECTRICBARRIER19
								or dll.state == S_CYBRAKDEMONELECTRICBARRIER20 or dll.state == S_CYBRAKDEMONELECTRICBARRIER21
								or dll.state == S_CYBRAKDEMONELECTRICBARRIER22 or dll.state == S_CYBRAKDEMONELECTRICBARRIER23
								or dll.state == S_CYBRAKDEMONELECTRICBARRIER24) then P_KillMobj(dll, player.mo, player.mo)
								elseif dll.type == MT_METALSONIC_BATTLE and dll.state == S_METALSONIC_FLOAT then
									dll.state = S_METALSONIC_PAIN
									if dll.health > 1 then dll.health = $ - 1
									elseif dll.health <= 1 then
										A_BossDeath(dll)
										dll.momx = 0
										dll.momy = 0
									end
								elseif dll.type == MT_EGGSHIELD then P_KillMobj(dll, player.mo, player.mo)
								elseif dll.type == MT_EGGMOBILE or dll.type == MT_EGGMOBILE or dll.type == MT_EGGMOBILE2
									or dll.type == MT_EGGMOBILE3 or dll.type == MT_EGGMOBILE4 or dll.type == MT_FANG
									or dll.type == MT_CYBRAKDEMON or dll.type == MT_BLACKEGGMAN then P_DamageMobj(dll, player.mo, player.mo, 2)
								else P_DamageMobj(dll, player.mo, player.mo) end
							end
							if protecteyes.value == 0 and (player.hyperflash and player.hyperflash == 1) then player.hyperflash = 0 end
							if protecteyes.value != 0 or (player.hyperflash != nil and player.hyperflash == 1) then
								P_FlashPal(player, PAL_WHITE, 5)
								P_StartQuake(50*FRACUNIT, 5)
							end
							player.xpcooldown = 55*TICRATE
							S_StartSound(player.mo, sfx_xpbmb)
							if player.rings <= 3 then player.rings = 0 else player.rings = $ - 3 end
							xp.destscale = player.mo.scale*32
							xp.scalespeed = player.mo.scale/6
							xp.fuse = 12
							for i = 0, 8, 1 do
								local sparkle = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SUPERSPARK)
								sparkle.angle = FixedAngle(i*ANGLE_22h)
								P_Thrust(sparkle, sparkle.angle, 40*FRACUNIT)
							end
						elseif player.hyper.capable then
							if hyperblast then
								// The AoE attack is overclocked to instability amounts!
								// You... should probably be careful about using it.
								// Because it's not just enemies that will feel it.
								if protecteyes.value != 0 then
									P_FlashPal(player, PAL_NUKE, TICRATE) // boom.
									P_StartQuake(150*FRACUNIT, 2*TICRATE)
								end
								player.xpcooldown = 0
								WhenYouStubYourToe(player)
								if FixedMul(player.speed, player.mo.scale) < 60*FRACUNIT then
									P_InstaThrust(player.mo, player.mo.angle, -60*FRACUNIT)
									P_SetObjectMomZ(player.mo, 30*FRACUNIT)
								else
									P_InstaThrust(player.mo, player.mo.angle, player.speed * -1)
									P_SetObjectMomZ(player.mo, player.speed / 3)
								end
								for dll in mobjs.iterate()
									local boss = false
									// Boss?
									if dll.type == MT_FANG or dll.type == MT_BLACKEGGMAN or dll.type == MT_CYBRAKDEMON
									or dll.type == MT_METALSONIC_RACE or dll.type == MT_METALSONIC_BATTLE then
										boss = true
									end
									// Might feel quite empty without those.
									if dll.type == MT_RING or dll.type == MT_FLINGRING or dll.type == MT_CORK
									or dll.type == MT_REDRING or dll.type == MT_LHRT or dll.type == MT_BOUNCERING
									or dll.type == MT_RAILRING or dll.type == MT_INFINITYRING or dll.type == MT_AUTOMATICRING
									or dll.type == MT_AUTOMATICRING or dll.type == MT_EXPLOSIONRING or dll.type == MT_SCATTERRING
									or dll.type == MT_GRENADERING or dll.type == MT_BOUNCEPICKUP or dll.type == MT_RAILPICKUP
									or dll.type == MT_AUTOPICKUP or dll.type == MT_EXPLODEPICKUP or dll.type == MT_SCATTERPICKUP
									or dll.type == MT_GRENADEPICKUP or dll.type == MT_THROWNBOUNCE or dll.type == MT_THROWNINFINITY
									or dll.type == MT_THROWNAUTOMATIC or dll.type == MT_THROWNSCATTER or dll.type == MT_THROWNEXPLOSION
									or dll.type == MT_THROWNGRENADE or dll.type == MT_COIN or dll.type == MT_FLINGCOIN or dll.type == MT_FIREBALL 
									or dll.type == MT_TOKEN or dll.type == MT_SUSPICIOUSFACESTABBERSTATUE or dll.type == MT_GLAREGOYLE
									or dll.type == MT_GLAREGOYLEUP or dll.type == MT_GLAREGOYLEDOWN or dll.type == MT_GLAREGOYLELONG then
										P_KillMobj(dll, player.mo, player.mo)
									elseif dll.type != MT_EGGROBO1 and not (boss or dll.type == MT_EGGSHIELD or dll.type == MT_EGGGUARD) then
										P_DamageMobj(dll, player.mo, player.mo, 4822, 128)
									else
										if dll.type == MT_EGGROBO1 or boss then
											if dll.type == MT_FANG or dll.type == MT_METALSONIC_RACE then
												dll.flags2 = $ | MF2_DONTDRAW
											end
											local boom = P_SpawnMobj(dll.x, dll.y, dll.z, MT_BOSSEXPLODE)
											boom.scale = 3 << FRACBITS
											dll.scale = 0
											if (dll.type == MT_METALSONIC_RACE or dll.type == MT_METALSONIC_BATTLE or dll.type == MT_CYBRAKDEMON)
											and logoff then
												if dll.type == MT_CYBRAKDEMON then P_GivePlayerRings(player, 95) end
												P_DoPlayerExit(player)
											end
										end
										P_KillMobj(dll, player.mo, player.mo)
									end
								end
								P_PlayRinglossSound(player.mo)
								P_PlayerRingBurst(player, 32)
								P_PlayerRingBurst(player, 32)
								xp.destscale = player.mo.scale*64
								xp.scalespeed = player.mo.scale/3
								xp.fuse = TICRATE*2
								xp.flags = $ & ~MF_NOCLIPHEIGHT
								player.rings = 0
								for i = 0, 8, 1 do
									local sparkle = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SUPERSPARK)
									sparkle.angle = FixedAngle(i*ANGLE_22h)
									P_Thrust(sparkle, sparkle.angle, 40*FRACUNIT)
								end
								player.powers[pw_sneakers] = 0
								player.powers[pw_invulnerability] = 0
								player.fakenormalspeed = skins[player.mo.skin].normalspeed
								player.hyper.capable = false
							else
								S_StartSound(player.mo, sfx_noblst, player)
								return
							end
						end
					player.xpready = false
					end
				end
			end
		// If it's PvP, though...
		elseif (G_RingSlingerGametype() and G_GametypeHasSpectators()) then
			if (All7Emeralds(player.powers[pw_emeralds]) or (player.powers[pw_sneakers] != 0 and player.powers[pw_invulnerability] != 0))
			and player.cmd.buttons & BT_CUSTOM1 then
				P_PlayerEmeraldBurst(player)
				P_PlayerFlagBurst(player)
				if mobjscale.value == 1 then
					P_NukeEnemies(player.mo, player.mo, 4096*FRACUNIT)
				else
					P_NukeEnemies(player.mo, player.mo, 2048*FRACUNIT)
				end
				S_StartSound(player.mo, sfx_nt5pwr)
				player.powers[pw_sneakers] = 0
				player.powers[pw_invulnerability] = 0
				P_DoPlayerPain(player)
				P_PlayRinglossSound(player.mo)
				P_SetObjectMomZ(player.mo, 10*FRACUNIT)
				P_InstaThrust(player.mo, player.mo.angle, -20*FRACUNIT)
				P_RestoreMusic(player)
			end
		end
	end
end)